-- *****************************************************
-- Icicles variables
-- *****************************************************
local tblIcicles = {}
local IcicleBaseDamage0, IcicleBaseDamage1, IcicleBaseDamage2, IcicleBaseDamage3, IcicleBaseDamage4 = 0

-- *****************************************************
-- Slash Commands
-- *****************************************************
SLASH_ICICLES1 = '/ici'
function SlashCmdList.ICICLES(msg, editbox)
	-- print('Ice Ice Baby!!!')
end
SLASH_ICICLES2 = '/ice'
function SlashCmdList.ICICLES(msg, editbox)
	-- print('Ice Ice Baby')
end

-- *****************************************************
-- Load
-- *****************************************************
function Icicles_Load()
	-- Events
	frmIciclesPrincipal:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	frmIciclesPrincipal:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	frmIciclesPrincipal:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	frmIciclesPrincipal:SetScript("OnEvent", EventListner)
	
	
	-- Interface
	MakeDynamicInterface()
		
	-- Start Checker
	C_Timer.After(0.1, IciclesCycle)

	CheckClassSpec()
end

function CheckClassSpec()
	local localizedClass, englishClass, classIndex = UnitClass("player")
	if classIndex == 8 then
		local currentSpec = GetSpecialization()
		if currentSpec == 3 then
			frmIciclesPrincipal:Show()
		else
			frmIciclesPrincipal:Hide()
		end
	else
		frmIciclesPrincipal:Hide()
	end
end

function MakeDynamicInterface()
	local name, rank, icon, castTime, minRange, maxRange = GetSpellInfo(76613)
	local size = 15
	for i = 1, 6 do
		local frame = CreateFrame("Frame","frmIciclesFrame"..i,frmIciclesPrincipal)
		frame:SetFrameStrata("BACKGROUND")
		frame:SetWidth(size)
		frame:SetHeight(size)

		local texture = frame:CreateTexture(nil, "BACKGROUND")
		texture:SetTexture(icon)
		texture:SetAllPoints(frame)
		frame.texture = texture

		frame.text = frame:CreateFontString("txtIciclesDamage"..i, "GameFontNormal")
		frame.text:SetFont("Fonts\\FRIZQT__.TTF", 15)
		-- frame.text:SetTextColor(0.85, 0.85, 0.85, 1)
		frame.text:ClearAllPoints()
		frame.text:SetPoint("TOPLEFT", size+(size/4), 0)
		frame.text:SetText("0")
		
		frame:SetPoint("TOPLEFT",size,i*-(size))

		local cooldown = CreateFrame("Cooldown", "frmCooldown"..i, frame)
		cooldown:SetAllPoints()

		frame:Show()

		tblIcicles[i] = {}
		tblIcicles[i].BaseDamage = 0
		tblIcicles[i].Timestamp = 0
		tblIcicles[i].Frame = frame
		tblIcicles[i].Cooldown = cooldown
	end
	
	tblIcicles[6].Frame:SetWidth(size*2)
	tblIcicles[6].Frame:SetHeight(size*2)
	tblIcicles[6].Frame:SetPoint("TOPLEFT",0,6*-(size))
	tblIcicles[6].Frame.text:SetPoint("TOPLEFT", (size*2)+(size/4), 0)
	tblIcicles[6].Frame.text:SetFont("Fonts\\FRIZQT__.TTF", 30)
end

-- *****************************************************
-- Combat Log Listener
-- *****************************************************
function EventListner(self, event, ...)
	if event == "ACTIVE_TALENT_GROUP_CHANGED" or event == "PLAYER_ENTERING_WORLD" then
		CheckClassSpec()
	else
		CombatLogFilter(self, event, ...)
	end
end

-- *****************************************************
-- Combat Log Listener
-- *****************************************************
function CombatLogFilter(self, event, ...)
	local playerName, playerRealm = UnitName("player")
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
	if (playerName == sourceName and type == "SPELL_DAMAGE") then
		local spellId, spellName, spellSchool = select(12, ...)
		if (spellId == 116 or spellId == 44614) then -- Frostbolt / Frostfire Bolt
			local damage = select(15, ...)
			SetupNewIcicle(damage, timestamp)
		end

		-- if (spellId == 148022) then -- Icicle
		-- 	local damage = select(15, ...)
		-- end
	end
	if (playerName == sourceName and type == "SPELL_CAST_SUCCESS") then
		local spellId, spellName, spellSchool = select(12, ...)
		if (spellId == 30455) then -- Ice Lance
			ShootIcicles()
		end
	end
end

-- *****************************************************
-- Create a new instance of Icicle
-- *****************************************************
function SetupNewIcicle(damage, timestamp)
	local minnorTimestamp = 999999999999
	local icicleIndex = 0
	for i = 1, 5 do
		if tblIcicles[i].BaseDamage == 0 then
			icicleIndex = i
			break
		end
		if tblIcicles[i].Timestamp < minnorTimestamp then
			icicleIndex = i
			minnorTimestamp = tblIcicles[i].Timestamp
		end
	end
	
	if tblIcicles[icicleIndex].BaseDamage > 0 then
		tblIcicles[icicleIndex].Timer:Cancel()
	end
	
	tblIcicles[icicleIndex].BaseDamage = damage
	tblIcicles[icicleIndex].Timer = C_Timer.NewTimer(30, function() SetDamageEmpty(tblIcicles[icicleIndex]) end)
	tblIcicles[icicleIndex].Timestamp = timestamp
	tblIcicles[icicleIndex].Cooldown:SetCooldown(GetTime(), 30)

end

-- *****************************************************
-- Icicle Cycle
-- *****************************************************
function IciclesCycle()
	local mastery, coefficient = GetMasteryEffect()
	local totalIcicleDamage = 0
	
	for i = 1, 5 do
		local icicleDamage = ((tblIcicles[i].BaseDamage) / 100) * mastery
		tblIcicles[i].Frame.text:SetText(math.floor(icicleDamage))
		totalIcicleDamage = totalIcicleDamage + icicleDamage
	end

	tblIcicles[6].Frame.text:SetText(math.floor(totalIcicleDamage))
	
	C_Timer.After(0.1, IciclesCycle)
end

-- *****************************************************
-- Initialize an Icicle instance
-- *****************************************************
function SetDamageEmpty(icicle)
	if icicle.Timer ~= nil then
		icicle.Timer:Cancel()
	end
	icicle.BaseDamage = 0
	-- icicle.Timer = nil
	icicle.Timestamp = 0
	icicle.Frame.text:SetText(0)
	icicle.Cooldown:SetCooldown(0, 0)
end

function ShootIcicles()

	local minnorTimestamp = 999999999999
	local icicleIndex = 0
	for i = 1, 5 do
		if tblIcicles[i].BaseDamage > 0 then
			if tblIcicles[i].Timestamp < minnorTimestamp then
				icicleIndex = i
				minnorTimestamp = tblIcicles[i].Timestamp
			end
		end
	end
	
	if icicleIndex > 0 then
		SetDamageEmpty(tblIcicles[icicleIndex])
		C_Timer.After(0.75, ShootIcicles)
	end
end












